## jppy 0.0.43

=== SConstruct ===
# -*- Python -*-

import glob
import sys
import distutils.sysconfig
import shutil, stat
import re
import os
import os.path
from helpers import *
import dbhash
import SCons

print """Please remember that SCons does NOT automatically use your shell
environment variables. This script uses PKG_CONFIG_PATH explicitly."""

SConsignFile('scons-signatures-db', dbhash)

opts = Options('SCustomize')

opts.Add(('python_version','Python library version to use','libpython2.4.so'))
opts.Add(PathOption('python_module_prefix','Prefix to install python module and extension to',
                    os.path.join(distutils.sysconfig.get_python_lib(),'jppy'),PathOption.PathAccept))
opts.Add(PathOption('prefix','Prefix to install /bin/<scripts> to',
                    '/usr/local'))
opts.Add(PathOption('mx_datetime_includes','Path to mx/mxDateTime.h',
                    '/usr/include/python%s' % sys.version[0:3], PathOption.PathIsDir ))
opts.Add(PathOption('python_includes','Path to Python.h',
                    '/usr/include/python%s' % sys.version[0:3], PathOption.PathIsDir ))
opts.Add(PathOption('pisock_includes','Path to pi-socket.h','/usr/include'))
opts.Add(PathOption('pisock_library','Path to libpisock.so','/usr/lib'))
opts.Add(PathOption('jppyroot','Install jppy to a different root than /',
                    '/',PathOption.PathIsDirCreate))
opts.Add(PathOption('jppyguiroot','Install jppy\'s gui to a different root than /',
                    '/',PathOption.PathIsDirCreate))
opts.Add(PathOption('jpilotroot','Install jpilot plugins to a different root than /',
                    '/',PathOption.PathIsDirCreate))
opts.Add(PackageOption('rpathoverride','Link with an rpath','no'))
opts.Add(BoolOption('test','Do you want to run the tests?','yes'))
opts.Add(BoolOption('profile','Do you want compile with profiling?','no'))

env = Environment(options=opts,
                  CCFLAGS=['-g',
                           '-DPYTHON_SHARED_LIB=\\"${python_version}\\"'],
                  LINKFLAGS=['-L$pisock_library'],
#                             distutils.sysconfig.get_config_var('LINKFORSHARED')],
#                             '-lpython%s' % sys.version[0:3]],
                  CPPPATH=['${mx_datetime_includes}',
                           '${pisock_includes}',
                           '${python_includes}',
                           '#/libversit_src'])
if env['profile']:
     env.Append(CCFLAGS='-pg')
     env.Append(LINKFLAGS='-pg')

SWIGScanner = SCons.Scanner.ClassicCPP(    "SWIGScan",
                                           ".i",
                                           "CPPPATH",
                                           """^[ \t]*[%,#][
                                           \t]*(?:include|import)[
                                           \t]*(<|")([^>"]+)(>|")""")
""" " """ # fix XEmacs' python syntax highlighting.
                                                     
env['SCANNERS'] += [SWIGScanner]


for take_from_env in ["PKG_CONFIG_PATH"]:
     if os.environ.has_key(take_from_env):
          env['ENV'][take_from_env] = os.environ[take_from_env]

if env['rpathoverride']:
     if env['rpathoverride'] in (1,'yes'):
          print "rpathoverride must be a path"
     else:
          env.Append(LINKFLAGS = '-Wl,--rpath=$rpathoverride -L$rpathoverride')

opts.Save('SCustomize',env)

config = env.Configure(custom_tests={'CheckPKGConfig' : CheckPKGConfig, 
                                     'CheckPKG' : CheckPKG })

Help(opts.GenerateHelpText(env))

if not config.CheckPKGConfig('0.15.0'): 
     print 'pkg-config >= 0.15.0 not found.' 
     Exit(1) 
 
if not config.CheckPKG('gtk+-2.0 >= 2.4.0'): 
     print 'gtk+-2.0 >= 2.4.0 not found.' 
     Exit(1)

if not config.CheckPKG('glib-2.0 >= 2.4.0'): 
     print 'glib-2.0 >= 2.4.0 not found.' 
     Exit(1)

if not config.CheckPKG('pygtk-2.0 >= 2.4.0'): 
     print 'pygtk-2.0 >= 2.4.0 not found.' 
     Exit(1)     
     
#standard stuff
for hdr in [['Python.h','mx/mxDateTime.h']]:
     if not config.CheckHeader(hdr):
          print "You need '%s' to compile this program" % hdr
          Exit(1)
          
if not config.CheckLibWithHeader('libpisock',
                                 'pi-socket.h','C','pi_socket_connected(0);'):
     print "You need libpisock to compile this program"
     Exit(1)

if not config.CheckLibWithHeader('libpython%s' % sys.version[0:3],
                                 'Python.h','C','PyErr_Clear();'):
     print "You need libpython%s.so to compile this program" % sys.version[0:3]
     Exit(1)
     
env.ParseConfig('pkg-config --cflags --libs gtk+-2.0')
env.ParseConfig('pkg-config --cflags --libs glib-2.0')
env.ParseConfig('pkg-config --cflags --libs pygtk-2.0') 

vars = distutils.sysconfig.get_config_vars('CC', 'CXX', 'OPT', 'BASECFLAGS',
                                           'CCSHARED', 'LDSHARED', 'SO') 
for i in range(len(vars)): 
    if vars[i] is None: 
        vars[i] = "" 
 
(pycc, pycxx, pyopt, pybasecflags, pyccshared, pyldshared, pyso_ext) = vars 


current_version = open("current-version", "r").read().strip()
top_version, major_version, minor_version = current_version.split(".")
if "~"  in minor_version:
     minor_version, extra_version = minor_version.split("~")
else:
     extra_version = ""

DEFINES_ALL=["JPPY_VERSION=%s" % current_version,
             "JPPY_MAJOR_VERSION=%s" % major_version,
             "JPPY_MINOR_VERSION=%s" % minor_version,
             "JPPY_EXTRA_VERSION=\\\"%s\\\"" % extra_version,             
             "ENABLE_GTK2"]
env.AppendUnique(CPPDEFINES=DEFINES_ALL)

env = config.Finish()

env['python_module_path'] = os.path.join(env['jppyroot'],
                                         env['python_module_prefix'][1:])
env['python_gui_module_path'] = os.path.join(env['jppyguiroot'],
                                             env['python_module_prefix'][1:])
env['jpilot_plugin_prefix'] = os.path.join(env['prefix'],
                                           "lib/jpilot/plugins")
env['jpilot_plugin_path'] = os.path.join(env['jpilotroot'],
                                         env['jpilot_plugin_prefix'][1:])

######### Jpilot
jpilot_sources = ['log', 'libplugin', 'utils', 'prefs',
                  'plugins', 'sync', 'japanese', 'cp1250',
                  'russian', 'password', 'category', 'otherconv']
# a bit of a hack. Scons doesn't support shared objects in static libraries.
libjpilot = env.StaticLibrary(target='jpilot_src/jppy_jpilot',
                              source = ["jpilot_src/%s.c" % x for x in jpilot_sources],
                              CCFLAGS="$CCFLAGS -fPIC")
libjpilot[0].attributes.shared = True


######### Jppy
jppymodule = env.SharedLibrary(target = 'jppy/__jpilotmodule',
                               source = ['python_module_src/jpilot.i',
                                         'python_module_src/move_into_libpisock.c',
                                         'python_module_src/jpilot_helpers.c',
                                         libjpilot] +
                               glob.glob("python_module_src/pytype*.c") +
                               ["libversit_src/%s" % x for x in ["vcc.y",
                                                                 "vobject.c",
                                                                 "vcaltmp.c"]],
                               SHLIBPREFIX="",
                               SHLIBSUFFIX=pyso_ext,
                               SWIGFLAGS="-python -outdir ./jppy/")

######### Jpilot Plugins
pluginEnv = env.Copy(SHLIBSUFFIX=pyso_ext,
                     SHLIBPREFIX="lib")
pluginEnv.Append(CPPPATH=['#/jpilot_src'])
pluginEnv.Append(CPPDEFINES='JPILOT_PLUGIN_PREFIX=\\"$jpilot_plugin_prefix\\"')
jpilot_plugins = []
for source in glob.glob('jpilot_plugins/*.c'):
     jpilot_plugins.append(pluginEnv.SharedLibrary(
          target = os.path.splitext(source)[0],
          source = source))
jpilot_plugins.append(File('#jpilot_plugins/jpilot_site.py'))
     

######### Tests
if env['test']:
     SConscript(dirs=['tests'],exports=['env','jppymodule'])

first_line_re = re.compile('^#!.*python[0-9.]*([ \t].*)?$')
tokens_re = re.compile('@@([^@]*)@@')

def copyFunc(dest, source, env):
    f = open(source, "r")
    first_line = f.readline()
    rest = f.read()

    first_line_match = first_line_re.match(first_line)
    tokens_match     = tokens_re.search(rest)
    if first_line_match or tokens_match:
         for token in tokens_re.finditer(rest):
              if env.has_key(token.group(1)):
                   print "Replacing %s with %s" % (token.group(0), env[token.group(1)])
                   rest = rest.replace(token.group(0), env[token.group(1)])
         outf = open(dest, "w")
         if first_line_match:
              post_interp = first_line_match.group(1) or ''
              if not distutils.sysconfig.python_build:
                   outf.write("#!%s%s\n" % 
                              (os.path.normpath(sys.executable),
                               post_interp))
              else:
                   outf.write("#!%s%s\n" %
                              (os.path.join(
                        distutils.sysconfig.get_config_var("BINDIR"),
                        "python" + sysconfig.get_config_var("EXE")),
                               post_interp))
         else:
              outf.writelines([first_line])
         outf.write(rest)
         outf.close()
         f.close()
    else:
         f.close()
         shutil.copy(source, dest)
    if env.has_key("INSTALL_PERMS"):
         os.chmod(dest, env['INSTALL_PERMS'])
    else:
         os.chmod(dest, 0644)         
    return 0

######### Install
env['INSTALL'] = copyFunc

env.Alias('install', Dir(env['python_module_path']))
env.Install(env['python_module_path'], [jppymodule +
                                        glob.glob("jppy/*py")])

env.Install(os.path.join(env['python_gui_module_path'],"gui"),
            [glob.glob("jppy/gui/*.py") +
             glob.glob("jppy/gui/*.txt") +
             glob.glob("jppy/gui/*.glade")])


env.Alias('install', Dir(env['jpilot_plugin_path']))
env.Install(env['jpilot_plugin_path'], jpilot_plugins)

SConscript(dirs=['scripts'],exports=['env'])

## jppy 0.0.45

=== SConstruct ===
--- 
+++ 
@@ -18,9 +18,12 @@
 
 opts = Options('SCustomize')
 
-opts.Add(('python_version','Python library version to use','libpython2.4.so'))
-opts.Add(PathOption('python_module_prefix','Prefix to install python module and extension to',
-                    os.path.join(distutils.sysconfig.get_python_lib(),'jppy'),PathOption.PathAccept))
+default_module_prefix = os.path.join(distutils.sysconfig.get_python_lib(),'jppy')
+
+opts.Add(PathOption('python_module_prefix','Prefix to install python module to',
+                    default_module_prefix,PathOption.PathAccept))
+opts.Add(PathOption('python_bin_module_prefix','Prefix to install python binary module to',
+                    default_module_prefix,PathOption.PathAccept))
 opts.Add(PathOption('prefix','Prefix to install /bin/<scripts> to',
                     '/usr/local'))
 opts.Add(PathOption('mx_datetime_includes','Path to mx/mxDateTime.h',
@@ -38,17 +41,20 @@
 opts.Add(PackageOption('rpathoverride','Link with an rpath','no'))
 opts.Add(BoolOption('test','Do you want to run the tests?','yes'))
 opts.Add(BoolOption('profile','Do you want compile with profiling?','no'))
+opts.Add('python_version','Python library version', sys.version[0:3])
 
 env = Environment(options=opts,
-                  CCFLAGS=['-g',
-                           '-DPYTHON_SHARED_LIB=\\"${python_version}\\"'],
-                  LINKFLAGS=['-L$pisock_library'],
-#                             distutils.sysconfig.get_config_var('LINKFORSHARED')],
-#                             '-lpython%s' % sys.version[0:3]],
+                  CCFLAGS=['-g'],
                   CPPPATH=['${mx_datetime_includes}',
                            '${pisock_includes}',
                            '${python_includes}',
                            '#/libversit_src'])
+
+if env['python_module_prefix'] != default_module_prefix and \
+   env['python_bin_module_prefix'] == default_module_prefix:
+     print "Making python_bin_module_prefix match your non-default python_module_prefix"
+     env['python_bin_module_prefix'] = env['python_module_prefix']
+
 if env['profile']:
      env.Append(CCFLAGS='-pg')
      env.Append(LINKFLAGS='-pg')
@@ -95,7 +101,10 @@
 
 if not config.CheckPKG('pygtk-2.0 >= 2.4.0'): 
      print 'pygtk-2.0 >= 2.4.0 not found.' 
-     Exit(1)     
+     Exit(1)
+
+env.ParseConfig('pkg-config --cflags --libs glib-2.0')
+env.ParseConfig('pkg-config --cflags --libs gtk+-2.0')
      
 #standard stuff
 for hdr in [['Python.h','mx/mxDateTime.h']]:
@@ -103,20 +112,6 @@
           print "You need '%s' to compile this program" % hdr
           Exit(1)
           
-if not config.CheckLibWithHeader('libpisock',
-                                 'pi-socket.h','C','pi_socket_connected(0);'):
-     print "You need libpisock to compile this program"
-     Exit(1)
-
-if not config.CheckLibWithHeader('libpython%s' % sys.version[0:3],
-                                 'Python.h','C','PyErr_Clear();'):
-     print "You need libpython%s.so to compile this program" % sys.version[0:3]
-     Exit(1)
-     
-env.ParseConfig('pkg-config --cflags --libs gtk+-2.0')
-env.ParseConfig('pkg-config --cflags --libs glib-2.0')
-env.ParseConfig('pkg-config --cflags --libs pygtk-2.0') 
-
 vars = distutils.sysconfig.get_config_vars('CC', 'CXX', 'OPT', 'BASECFLAGS',
                                            'CCSHARED', 'LDSHARED', 'SO') 
 for i in range(len(vars)): 
@@ -144,6 +139,8 @@
 
 env['python_module_path'] = os.path.join(env['jppyroot'],
                                          env['python_module_prefix'][1:])
+env['python_bin_module_path'] = os.path.join(env['jppyroot'],
+                                         env['python_bin_module_prefix'][1:])
 env['python_gui_module_path'] = os.path.join(env['jppyguiroot'],
                                              env['python_module_prefix'][1:])
 env['jpilot_plugin_prefix'] = os.path.join(env['prefix'],
@@ -152,40 +149,74 @@
                                          env['jpilot_plugin_prefix'][1:])
 
 ######### Jpilot
+jpilotEnv = env.Clone()
+jpilotConfig = jpilotEnv.Configure()
+if not jpilotConfig.CheckLibWithHeader('libpisock',
+                                       'pi-socket.h','C','pi_socket_connected(0);'):
+     print "You need libpisock to compile this program"
+     Exit(1)
+jpilotConfig.Finish()
 jpilot_sources = ['log', 'libplugin', 'utils', 'prefs',
                   'plugins', 'sync', 'japanese', 'cp1250',
                   'russian', 'password', 'category', 'otherconv']
 # a bit of a hack. Scons doesn't support shared objects in static libraries.
-libjpilot = env.StaticLibrary(target='jpilot_src/jppy_jpilot',
-                              source = ["jpilot_src/%s.c" % x for x in jpilot_sources],
-                              CCFLAGS="$CCFLAGS -fPIC")
+libjpilot = jpilotEnv.StaticLibrary(target='jpilot_src/jppy_jpilot',
+                                    source = ["jpilot_src/%s.c" % x for x in jpilot_sources],
+                                    CCFLAGS="$CCFLAGS -fPIC")
 libjpilot[0].attributes.shared = True
 
 
 ######### Jppy
-jppymodule = env.SharedLibrary(target = 'jppy/__jpilotmodule',
-                               source = ['python_module_src/jpilot.i',
-                                         'python_module_src/move_into_libpisock.c',
-                                         'python_module_src/jpilot_helpers.c',
-                                         libjpilot] +
-                               glob.glob("python_module_src/pytype*.c") +
-                               ["libversit_src/%s" % x for x in ["vcc.y",
-                                                                 "vobject.c",
-                                                                 "vcaltmp.c"]],
-                               SHLIBPREFIX="",
-                               SHLIBSUFFIX=pyso_ext,
-                               SWIGFLAGS="-python -outdir ./jppy/")
+jppyEnv = jpilotEnv.Clone()
+jppyEnv.ParseConfig('pkg-config --cflags --libs pygtk-2.0')      
+jppymodule = jppyEnv.SharedLibrary(target = 'jppy/__jpilotmodule',
+                                   source = ['python_module_src/jpilot.i',
+                                             'python_module_src/move_into_libpisock.c',
+                                             'python_module_src/jpilot_helpers.c',
+                                             libjpilot] +
+                                   glob.glob("python_module_src/pytype*.c") +
+                                   ["libversit_src/%s" % x for x in ["vcc.y",
+                                                                     "vobject.c",
+                                                                     "vcaltmp.c"]],
+                                   SHLIBPREFIX="",
+                                   SHLIBSUFFIX=pyso_ext,
+                                   SWIGFLAGS="-python -outdir ./jppy/")
 
 ######### Jpilot Plugins
-pluginEnv = env.Copy(SHLIBSUFFIX=pyso_ext,
-                     SHLIBPREFIX="lib")
+
+pluginEnv = env.Clone(SHLIBSUFFIX=pyso_ext,
+                      SHLIBPREFIX="lib")
 pluginEnv.Append(CPPPATH=['#/jpilot_src'])
-pluginEnv.Append(CPPDEFINES='JPILOT_PLUGIN_PREFIX=\\"$jpilot_plugin_prefix\\"')
+
+pluginEnv.Append(CPPDEFINES=['JPILOT_PLUGIN_PREFIX=\\"$jpilot_plugin_prefix\\"'])
+
+jppyPluginEnv = pluginEnv.Clone()
+jppyPluginEnv.Append(CPPDEFINES=['PYTHON_SHARED_LIB=\\"libpython${python_version}.so\\"'])
+jppyPluginConfig = jppyPluginEnv.Configure()
+if not jppyPluginConfig.CheckLibWithHeader("libpython%s" % env['python_version'], 
+                                           'Python.h','C','PyErr_Clear();'): 
+     print "You need libpython%s.so to compile this program" % env['python_version']
+     Exit(1) 
+jppyPluginConfig.Finish()
+jppyPluginEnv.Append(LINKFLAGS=distutils.sysconfig.get_config_var('LINKFORSHARED'))
+
 jpilot_plugins = []
-for source in glob.glob('jpilot_plugins/*.c'):
-     jpilot_plugins.append(pluginEnv.SharedLibrary(
-          target = os.path.splitext(source)[0],
-          source = source))
+
+jpilot_plugins.append(jppyPluginEnv.SharedLibrary(target = "jpilot_plugins/jppy",
+                                                  source = "jpilot_plugins/jppy.c"))
+
+jpilot_plugins.append(pluginEnv.SharedLibrary(target = "jpilot_plugins/sync-Contacts",
+                                              source = "jpilot_plugins/sync-Contacts.c"))
+
+jpilot_plugins.append(pluginEnv.SharedLibrary(target = "jpilot_plugins/sync-PTimLogA",
+                                              source = "jpilot_plugins/sync-PTimLogA.c"))
+
+jpilot_plugins.append(pluginEnv.SharedLibrary(target = "jpilot_plugins/sync-PTimLogB",
+                                              source = "jpilot_plugins/sync-PTimLogB.c"))
+
+jpilot_plugins.append(pluginEnv.SharedLibrary(target = "jpilot_plugins/sync-PTimLogC",
+                                              source = "jpilot_plugins/sync-PTimLogC.c"))
+
 jpilot_plugins.append(File('#jpilot_plugins/jpilot_site.py'))
      
 
@@ -239,8 +270,8 @@
 env['INSTALL'] = copyFunc
 
 env.Alias('install', Dir(env['python_module_path']))
-env.Install(env['python_module_path'], [jppymodule +
-                                        glob.glob("jppy/*py")])
+env.Install(env['python_module_path'], glob.glob("jppy/*py"))
+env.Install(env['python_bin_module_path'], jppymodule)
 
 env.Install(os.path.join(env['python_gui_module_path'],"gui"),
             [glob.glob("jppy/gui/*.py") +

## jppy 0.0.47

=== SConstruct ===
--- 
+++ 
@@ -10,6 +10,7 @@
 from helpers import *
 import dbhash
 import SCons
+import commands
 
 print """Please remember that SCons does NOT automatically use your shell
 environment variables. This script uses PKG_CONFIG_PATH explicitly."""
@@ -190,15 +191,17 @@
 
 pluginEnv.Append(CPPDEFINES=['JPILOT_PLUGIN_PREFIX=\\"$jpilot_plugin_prefix\\"'])
 
+
 jppyPluginEnv = pluginEnv.Clone()
-jppyPluginEnv.Append(CPPDEFINES=['PYTHON_SHARED_LIB=\\"libpython${python_version}.so\\"'])
+jppyPluginEnv.Append(LINKFLAGS=distutils.sysconfig.get_config_var('LINKFORSHARED'))
 jppyPluginConfig = jppyPluginEnv.Configure()
 if not jppyPluginConfig.CheckLibWithHeader("libpython%s" % env['python_version'], 
                                            'Python.h','C','PyErr_Clear();'): 
      print "You need libpython%s.so to compile this program" % env['python_version']
      Exit(1) 
 jppyPluginConfig.Finish()
-jppyPluginEnv.Append(LINKFLAGS=distutils.sysconfig.get_config_var('LINKFORSHARED'))
+python_library_filename = commands.getoutput("./find-python-library-name.sh libpython%s.so" % env['python_version'])
+jppyPluginEnv.Append(CPPDEFINES=['PYTHON_SHARED_LIB=\\"%s\\"' % python_library_filename])
 
 jpilot_plugins = []

## jppy 0.0.56

=== SConstruct ===
# -*- Python -*-

import glob
import sys
import distutils.sysconfig
import shutil, stat
import re
import os
import os.path
from helpers import *
import SCons
import commands
import platform

print """Please remember that SCons does NOT automatically use your shell
environment variables. This script uses PKG_CONFIG_PATH explicitly."""

opts = Variables('SCustomize')

default_module_prefix = os.path.join(distutils.sysconfig.get_python_lib(),'jppy')

opts.Add(PathVariable('python_module_prefix','Prefix to install python module to',
                    default_module_prefix,PathVariable.PathAccept))
opts.Add(PathVariable('python_bin_module_prefix','Prefix to install python binary module to',
                    default_module_prefix,PathVariable.PathAccept))
opts.Add(PathVariable('prefix','Prefix to install /bin/<scripts> to',
                    '/usr/local'))
opts.Add(PathVariable('mx_datetime_includes','Path to mxDateTime.h',
                    '/usr/include/python%s/mx' % sys.version[0:3], PathVariable.PathIsDir ))
opts.Add(PathVariable('python_includes','Path to Python.h',
                    '/usr/include/python%s' % sys.version[0:3], PathVariable.PathIsDir ))
opts.Add(PathVariable('pisock_includes','Path to pi-socket.h','/usr/include'))
if '64bit' == platform.architecture()[0]:
     opts.Add(PathVariable('pisock_library','Path to libpisock.so','/usr/lib64'))
else:
     opts.Add(PathVariable('pisock_library','Path to libpisock.so','/usr/lib'))
     
opts.Add(PathVariable('jppyroot','Install jppy to a different root than /',
                    '/',PathVariable.PathIsDirCreate))
opts.Add(PathVariable('jppyguiroot','Install jppy\'s gui to a different root than /',
                    '/',PathVariable.PathIsDirCreate))
if not 'darwin' == sys.platform:
     # Mac doesn't support dlopen(), so jpilot doesn't build there
     opts.Add(PathVariable('jpilotroot','Install jpilot plugins to a different root than /',
                         '/',PathVariable.PathIsDirCreate))
opts.Add(PackageVariable('rpathoverride','Link with an rpath','no'))
opts.Add(BoolVariable('test','Do you want to run the tests?','yes'))
opts.Add(BoolVariable('docs','Do you want to generate documentation?','no'))
opts.Add(BoolVariable('profile','Do you want compile with profiling?','no'))
opts.Add('python_version','Python library version', sys.version[0:3])

env = Environment(options=opts,
                  CCFLAGS=['-g'],
                  CPPPATH=['${mx_datetime_includes}',
                           '${pisock_includes}',
                           '${python_includes}',
                           '#/libversit_src'],
                  LIBPATH=['${pisock_library}'],
                  tools = ["default", "doxygen"],
                  toolpath='.',
                  ENV = {'PATH' : os.environ['PATH'],
                         'HOME' : os.environ['HOME'],
                         'TERM' : os.environ.get('TERM',''),}
                  )

if env['docs']:
     env.Doxygen("Doxyfile")

if env['python_module_prefix'] != default_module_prefix and \
   env['python_bin_module_prefix'] == default_module_prefix:
     print "Making python_bin_module_prefix match your non-default python_module_prefix"
     env['python_bin_module_prefix'] = env['python_module_prefix']

if env['profile']:
     env.Append(CCFLAGS='-pg')
     env.Append(LINKFLAGS='-pg')

SWIGScanner = SCons.Scanner.ClassicCPP(    "SWIGScan",
                                           ".i",
                                           "CPPPATH",
                                           """^[ \t]*[%,#][
                                           \t]*(?:include|import)[
                                           \t]*(<|")([^>"]+)(>|")""")
""" " """ # fix XEmacs' python syntax highlighting.
                                                     
env['SCANNERS'] += [SWIGScanner]


for take_from_env in ["PKG_CONFIG_PATH"]:
     if os.environ.has_key(take_from_env):
          env['ENV'][take_from_env] = os.environ[take_from_env]

if env['rpathoverride']:
     if env['rpathoverride'] in (1,'yes'):
          print "rpathoverride must be a path"
     else:
          env.Append(LINKFLAGS = '-Wl,--rpath=$rpathoverride -L$rpathoverride')

opts.Save('SCustomize',env)

config = env.Configure(custom_tests={'CheckPKGConfig' : CheckPKGConfig, 
                                     'CheckPKG' : CheckPKG })

Help(opts.GenerateHelpText(env))

if not config.CheckPKGConfig('0.15.0'):
     print 'pkg-config >= 0.15.0 not found.' 
     Exit(1) 
 
if not config.CheckPKG('gtk+-2.0 >= 2.4.0'): 
     print 'gtk+-2.0 >= 2.4.0 not found.' 
     Exit(1)

if not config.CheckPKG('glib-2.0 >= 2.4.0'): 
     print 'glib-2.0 >= 2.4.0 not found.' 
     Exit(1)

if not config.CheckPKG('pygtk-2.0 >= 2.4.0'): 
     print 'pygtk-2.0 >= 2.4.0 not found.' 
     Exit(1)

try:
     import pytz
except ImportError:
     print 'module pytz is required for jppy'
     Exit(1)

try:
     import MySQLdb
except ImportError:
     print 'module MySQLdb is required for jppy'
     Exit(1)

try:
     import pisock
except ImportError:
     print 'module pisock is required for jppy'
     Exit(1)

try:
     import pyparsing
except ImportError:
     print 'module pyparsing is required for jppy'
     Exit(1)

env.ParseConfig('pkg-config --cflags --libs glib-2.0')
env.ParseConfig('pkg-config --cflags --libs gtk+-2.0')
     
#standard stuff
for hdr in [['Python.h','mxDateTime.h']]:
     if not config.CheckHeader(hdr):
          print "You need '%s' to compile this program" % hdr
          Exit(1)
          
vars = distutils.sysconfig.get_config_vars('CC', 'CXX', 'OPT', 'BASECFLAGS',
                                           'CCSHARED', 'LDSHARED', 'SO') 
for i in range(len(vars)): 
    if vars[i] is None: 
        vars[i] = "" 
 
(pycc, pycxx, pyopt, pybasecflags, pyccshared, pyldshared, pyso_ext) = vars 


current_version = open("current-version", "r").read().strip()
top_version, major_version, minor_version = current_version.split(".")
if "~"  in minor_version:
     minor_version, extra_version = minor_version.split("~")
else:
     extra_version = ""

DEFINES_ALL=["JPPY_VERSION=%s" % current_version,
             "JPPY_MAJOR_VERSION=%s" % major_version,
             "JPPY_MINOR_VERSION=%s" % minor_version,
             "JPPY_EXTRA_VERSION=\\\"%s\\\"" % extra_version,             
             "ENABLE_GTK2"]
env.AppendUnique(CPPDEFINES=DEFINES_ALL)

env = config.Finish()

env['python_module_path'] = os.path.join(env['jppyroot'],
                                         env['python_module_prefix'][1:])
env['python_bin_module_path'] = os.path.join(env['jppyroot'],
                                         env['python_bin_module_prefix'][1:])
env['python_gui_module_path'] = os.path.join(env['jppyguiroot'],
                                             env['python_module_prefix'][1:])

if not 'darwin' == sys.platform:
     # Mac doesn't support dlopen(), so jpilot doesn't build there
     env['jpilot_plugin_prefix'] = os.path.join(env['prefix'],
                                                "lib/jpilot/plugins")
     env['jpilot_plugin_path'] = os.path.join(env['jpilotroot'],
                                              env['jpilot_plugin_prefix'][1:])

######### Jpilot
jpilotEnv = env.Clone()
if not 'darwin' == sys.platform:
     jpilotEnv.AppendUnique(CPPDEFINES=["ENABLE_PLUGINS"])

jpilotConfig = jpilotEnv.Configure()
if not jpilotConfig.CheckLibWithHeader('libpisock',
                                       'pi-socket.h','C','pi_socket_connected(0);'):
     print "You need libpisock to compile this program"
     Exit(1)
jpilotConfig.Finish()
jpilot_sources = ['log', 'libplugin', 'utils', 'prefs',
                  'plugins', 'sync', 'japanese', 'cp1250',
                  'russian', 'password', 'category', 'otherconv',
                  'jp-contact']
# a bit of a hack. Scons doesn't support shared objects in static libraries.
libjpilot = jpilotEnv.StaticLibrary(target='jpilot_src/jppy_jpilot',
                                    source = ["jpilot_src/%s.c" % x for x in jpilot_sources],
                                    CCFLAGS="$CCFLAGS -fPIC")
libjpilot[0].attributes.shared = True

######### Jppy
jppyEnv = jpilotEnv.Clone()
jppyEnv.ParseConfig('pkg-config --cflags --libs pygtk-2.0')
if 'darwin' == sys.platform:
     # Something is different on Mac that causes the shared symbols to not be found at compile time unless I link with libpython. This needs more investigation...
     jppyEnv.Append(LIBS = ['python'])
     
jppymodule = jppyEnv.SharedLibrary(target = 'jppy/__jpilotmodule',
                                   source = ['python_module_src/jpilot.i',
                                             'python_module_src/move_into_libpisock.c',
                                             'python_module_src/jpilot_helpers.c',
                                             libjpilot] +
                                   glob.glob("python_module_src/pytype*.c") +
                                   ["libversit_src/%s" % x for x in ["vcc.y",
                                                                     "vobject.c",
                                                                     "vcaltmp.c"]],
                                   SHLIBPREFIX="",
                                   SHLIBSUFFIX=pyso_ext,
                                   SWIGFLAGS="-python -outdir ./jppy/",
                                   )

######### Jpilot Plugins

if not 'darwin' == sys.platform:
     # Mac doesn't support dlopen(), so jpilot doesn't build there
     
     pluginEnv = env.Clone(SHLIBSUFFIX=pyso_ext,
                           SHLIBPREFIX="lib")
     pluginEnv.Append(CPPPATH=['#/jpilot_src'])

     pluginEnv.Append(CPPDEFINES=['JPILOT_PLUGIN_PREFIX=\\"$jpilot_plugin_prefix\\"'])

     jppyPluginEnv = pluginEnv.Clone()
     linkflags=distutils.sysconfig.get_config_var('LINKFORSHARED')
     jppyPluginEnv.Append(LINKFLAGS=[linkflags])
     jppyPluginConfig = jppyPluginEnv.Configure()
     if not jppyPluginConfig.CheckLibWithHeader("libpython%s" % env['python_version'], 
                                                'Python.h','C','PyErr_Clear();'): 
          print "You need libpython%s.so to compile this program" % env['python_version']
          Exit(1) 
     jppyPluginConfig.Finish()
     python_library_filename = commands.getoutput("./find-python-library-name.sh libpython%s.so" % env['python_version'])
     jppyPluginEnv.Append(CPPDEFINES=['PYTHON_SHARED_LIB=\\"%s\\"' % python_library_filename])

     jpilot_plugins = []

     jpilot_plugins.append(jppyPluginEnv.SharedLibrary(target = "jpilot_plugins/jppy",
                                                       source = "jpilot_plugins/jppy.c"))

     jpilot_plugins.append(pluginEnv.SharedLibrary(target = "jpilot_plugins/sync-Calendar",
                                                   source = "jpilot_plugins/sync-Calendar.c"))

######### Run Tests
if env['test']:
     SConscript(dirs=['tests'],exports=['env','jppymodule'])

first_line_re = re.compile('^#!.*python[0-9.]*([ \t].*)?$')
tokens_re = re.compile('@@([^@]*)@@')

def copyFunc(dest, source, env):
    f = open(source, "r")
    first_line = f.readline()
    rest = f.read()

    first_line_match = first_line_re.match(first_line)
    tokens_match     = tokens_re.search(rest)
    if first_line_match or tokens_match:
         for token in tokens_re.finditer(rest):
              if env.has_key(token.group(1)):
                   print "Replacing %s with %s" % (token.group(0), env[token.group(1)])
                   rest = rest.replace(token.group(0), env[token.group(1)])
         outf = open(dest, "w")
         if first_line_match:
              post_interp = first_line_match.group(1) or ''
              if not distutils.sysconfig.python_build:
                   outf.write("#!%s%s\n" % 
                              (os.path.normpath(sys.executable),
                               post_interp))
              else:

## jppy 0.0.59-1

=== SConstruct ===
--- 
+++ 
@@ -59,7 +59,7 @@
                   tools = ["default", "doxygen"],
                   toolpath='.',
                   ENV = {'PATH' : os.environ['PATH'],
-                         'HOME' : os.environ['HOME'],
+                         'HOME' : os.environ.get('HOME',''),
                          'TERM' : os.environ.get('TERM',''),}
                   )
 
@@ -245,7 +245,7 @@
      pluginEnv.Append(CPPDEFINES=['JPILOT_PLUGIN_PREFIX=\\"$jpilot_plugin_prefix\\"'])
 
      jppyPluginEnv = pluginEnv.Clone()
-     linkflags=distutils.sysconfig.get_config_var('LINKFORSHARED')
+     linkflags=distutils.sysconfig.get_config_var('LINKFORSHARED').split()
      jppyPluginEnv.Append(LINKFLAGS=[linkflags])
      jppyPluginConfig = jppyPluginEnv.Configure()
      if not jppyPluginConfig.CheckLibWithHeader("libpython%s" % env['python_version'], 
@@ -290,4 +290,3 @@
                    outf.write("#!%s%s\n" % 
                               (os.path.normpath(sys.executable),
                                post_interp))
-              else:

=== debian/changelog ===
jppy (0.0.59-1) unstable; urgency=low

  * New upstream release
  * Bug fix: "FTBFS if HOME is unset: KeyError: &#39;HOME&#39;", thanks to
    Jakub Wilk (Closes: #626800).

 -- Nicholas C Piper <nick-debian@nickpiper.co.uk>  Sat, 25 Jun 2011 09:49:39 +0100

jppy (0.0.58-1) unstable; urgency=low

  * New upstream release

 -- Nicholas C Piper <nick-debian@nickpiper.co.uk>  Sun, 15 May 2011 00:55:05 +0100

jppy (0.0.57-1) unstable; urgency=low

  * Fix building with Debian unstable (Closes: #626421).

 -- Nicholas C Piper <nick-debian@nickpiper.co.uk>  Sat, 14 May 2011 23:48:01 +0100

jppy (0.0.56-1.1) unstable; urgency=low

  * Non-maintainer upload.
  * Bug fix, the plugin should be compiled against the current debian python
    version. (Closes: #586930) Applying patch proposed by:
    Jakub Wilk <jwilk@debian.org>

 -- Maximiliano Curia <maxy@debian.org>  Tue, 03 Aug 2010 20:37:23 -0400

jppy (0.0.56-1) unstable; urgency=low

  [ Nicholas C Piper ]
  * Bug fix: "FTBFS on ia64: segmentation fault (unaligned access?)",
    thanks to Jakub Wilk (Closes: #574741).

  [ Norbert Preining ]
  * debian/control lintian warning fixes:
    - add misc:Depends deps to jppy-doc, jppy, jppy-lbdb-module
    - bump standards version to 3.9.0, no changes necessary

 -- Norbert Preining <preining@debian.org>  Thu, 01 Jul 2010 15:49:20 +0900

jppy (0.0.55-1) unstable; urgency=low

  * Upstream made compatible with pilot-link 0.12.5 (Closes:  #569363)

 -- Nicholas C Piper <nick-debian@nickpiper.co.uk>  Sun, 21 Feb 2010 22:26:04 +0000

jppy (0.0.54-3) unstable; urgency=low

  * Bug fix: "FTBFS: scons: *** Path for option pisock_library does not
    exist: /usr/lib64" (Closes: #558670)

 -- Nicholas C Piper <nick-debian@nickpiper.co.uk>  Sun, 21 Feb 2010 19:45:37 +0000

jppy (0.0.54-2) unstable; urgency=low

  * Fix "jppy 0.0.54-1 should depend on python-mysqldb, in order to make
    jppy work". Added to depends for python-jppy (Closes: #565425)

 -- Nicholas C Piper <nick-debian@nickpiper.co.uk>  Mon, 25 Jan 2010 19:53:50 +0000

jppy (0.0.54-1) unstable; urgency=low

  * Bug fix in upstream: "jppy - FTBFS: KeyError: 'TERM'" (Closes: #554088)

 -- Nicholas C Piper <nick-debian@nickpiper.co.uk>  Wed, 04 Nov 2009 22:41:50 +0000

jppy (0.0.53-1) unstable; urgency=low

  * Correction to version number

 -- Nicholas C Piper <nick-debian@nickpiper.co.uk>  Mon, 26 Oct 2009 20:53:35 +0000

jppy (0.0.52-1) unstable; urgency=low

  * Change jppy homepage in control file to current URL (Closes: #515171).
  * Corrections to how we use python-support (Closes: #516304).
  * Upstream has moved glade files into /usr/share/jppy
  * Bug fix: "should depend on python-gtkspell instead on
    python-gnome2-extras", thanks to Josselin Mouette (Closes: #541594).
  * Upstream now supports pilot-link 0.12.4 (Closes: #533944, #537244).
  * Drop Python2.4 support since pygobject did in 2.15.4-1

 -- Nicholas C Piper <nick-debian@nickpiper.co.uk>  Mon, 26 Oct 2009 20:13:55 +0000

jppy (0.0.48-1) experimental; urgency=low

  * New upstream release
  * Change VCS location to new git repository
  * Acknowledge NMU, thanks. (Closes: #496748)

 -- Nicholas C Piper <nick-debian@nickpiper.co.uk>  Wed, 08 Oct 2008 17:57:42 +0100

jppy (0.0.47-1.1) unstable; urgency=low

  * Non-maintainer upload.
  * Moved python-vobject, jpilot from Recommends: to Depends: (Closes: 496748)

 -- Mike O'Connor <stew@debian.org>  Sat, 04 Oct 2008 21:16:11 -0400

jppy (0.0.47-1) unstable; urgency=low

  * New upstream release (closes: #491848, #493082).

 -- martin f. krafft <madduck@debian.org>  Tue, 26 Aug 2008 13:12:23 +0100

jppy (0.0.45-1) unstable; urgency=low

  * New upstream version, which now builds for all supported Python versions
    and installs arch-dependent stuff to /usr/lib (closes: #488317). Thanks to
    Nick Piper, who did all the work!
  * Change maintainer to the new jppy-devel mailing list.

 -- martin f. krafft <madduck@debian.org>  Sat, 28 Jun 2008 12:48:24 +0200

jppy (0.0.44-2) unstable; urgency=low

  * Do not limit ourselves to a single Python version (closes: #488307).
  * Fix migration from python-central to python-support and clean up after
    python-central (see #479852).

 -- martin f. krafft <madduck@debian.org>  Fri, 27 Jun 2008 20:45:02 +0200

jppy (0.0.44-1) unstable; urgency=low

  * New upstream release (closes: #445379, #476679).
  * Completely redo the Debian packaging:
    - rewrite debian/rules
    - use python-support to build for the current Python version.
    - jppy recommends jpilot to make the stock PDB files available.
    - bump Standards-Version to 3.8.0; no changes needed.
    - update Vcs-* headers to point to git.debian.org.
    - add Homepage field.
    - depend on python-tz, which python-jppy now uses.
    - add build-dependencies on python-tz, python-pisock, python-reportlab,
      and python-vobject.
    - move menu entry from Apps/Tools to Applications/Data Management as per
      the Debian menu sub-policy.

 -- martin f. krafft <madduck@debian.org>  Fri, 02 May 2008 00:26:50 +0100

jppy (0.0.43-1) unstable; urgency=low

  * New upstream release.
  * First release to Debian unstable.
  * Updated the copyright file to include all licences used by jppy.

 -- martin f. krafft <madduck@debian.org>  Wed, 04 Jul 2007 20:25:35 +0200

jppy (0.0.41-1) unstable; urgency=low

  * New upstream release, which adds jp_*lookup scripts and fixes a problem
    with the lbdb module's use of exec.

 -- martin f. krafft <madduck@debian.org>  Thu, 24 May 2007 17:04:01 +0200

jppy (0.0.40-1) unstable; urgency=low

  * Resynchronised with head revision.
  * Only build against current python version, not all of them.
  * New package: jppy-lbdb-module, which allows lbdb to query the jppy
    Contacts-PAdd database.

 -- martin f. krafft <madduck@debian.org>  Thu, 24 May 2007 17:03:54 +0200

jppy (0.0.39+svn+r224-1~unreleased.2) UNRELEASED; urgency=low

  * Make jppy depend on python-vobject.



=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# This has to be exported to make some magic below work.
export DH_OPTIONS

DESTDIR := $(CURDIR)/debian/tmp
PYVER=$(shell pyversions -vd)
PYVERS=$(filter-out $(PYVER),$(shell pyversions -vr)) $(PYVER)

configure: configure-stamp
configure-stamp:
	rm -f SCustomize

build: configure $(PYVERS:%=build-python%-stamp)

clean:
	dh_testdir
	dh_testroot
	-scons -c
	rm -f jppy/_jpilot.py
	find . -name \*.pyc -exec rm {} \;
	rm -f config.log
	rm -f scons-signatures-db SCustomize tests_pass .sconsign.dblite
	rm -rf .sconf_temp
	rm -f testhome/.jpilot/*.pc3 testhome/.jpilot/next_id testhome/.jpilot/jpilot.log
	dh_clean

build-python%-stamp:
	# build the binary module for each python we support
	scons prefix=/usr jppyroot=$(DESTDIR) jppyguiroot=$(DESTDIR) jpilotroot=$(DESTDIR) \
	      python_version=$* \
	      python_includes=/usr/include/python$* \
	      mx_datetime_includes=/usr/include/python$*/mx \
	      python_bin_module_prefix=/usr/lib/python$*/site-packages/jppy \
	      python_module_prefix=/usr/lib/python$*/site-packages/jppy \
	      pisock_library=/usr/lib
	scons install
	touch $@

install: build 
	dh_installdirs

	# scons sucks, not only because it dereferences links on install
	for i in address email mobile phone vcard; do \
		ln -sf jp_lookup $(DESTDIR)/usr/bin/jp_$${i}_lookup; \
	done

	install -d -m755 $(DESTDIR)/usr/lib/lbdb
	install -m755 lbdb/m_palm_db6 lbdb/palm_db6_lsaddr \
		$(DESTDIR)/usr/lib/lbdb

binary-indep: build install
	dh_testdir -i
	dh_testroot -i
	dh_installdocs -i
	dh_installexamples -i
	dh_installmenu -i
	dh_installman -i
	dh_installchangelogs -i
	dh_install -i --sourcedir=$(DESTDIR) --autodest
	dh_pysupport -i
	dh_compress -i
	dh_fixperms -i
	dh_installdeb -i
	dh_gencontrol -i
	dh_md5sums -i
	dh_builddeb -i

binary-arch: build install
	dh_testdir -a
	dh_testroot -a
	dh_installdocs -a
	dh_installexamples -a
	dh_installmenu -a
	dh_installman -a
	dh_installchangelogs -a
	dh_install -a --sourcedir=$(DESTDIR) --autodest
	dh_pysupport -a
	dh_strip -a
	dh_compress -a
	dh_fixperms -a
	dh_installdeb -a
	dh_shlibdeps -a
	dh_gencontrol -a
	dh_md5sums -a
	dh_builddeb -a

binary: binary-indep binary-arch
.PHONY: clean binary-indep binary-arch install configure build

## jppy 0.0.59-1build1

=== debian/changelog ===
jppy (0.0.59-1build1) precise; urgency=low

  * Rebuild to drop python2.6 dependencies and provides.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 14 Apr 2012 13:42:46 +0000

=== debian/control ===
Source: jppy
Section: python
Priority: optional
Maintainer: jppy development team <jppy-devel@zanu.org.uk>
Uploaders: Nicholas C Piper <nick-debian@nickpiper.co.uk>, Norbert Preining <preining@debian.org>, martin f. krafft <madduck@debian.org>
Standards-Version: 3.9.0
Build-Depends: debhelper (>= 7), scons, swig, libgtk2.0-dev, python-gtk2-dev, bison, libpisock-dev (>= 0.12.5), python-egenix-mx-base-dev, python-egenix-mxdatetime, python-dev, python-glade2, python-gtkspell, python-gnome2, python-all-dev, python-support (>= 0.5.3), python-dateutil, python-tz, python-pisock (>= 0.12.2-11), python-vobject, python-reportlab, python-mysqldb, python-pyparsing, python-imaging
Vcs-Git: git://git.debian.org/git/jppy/jppy.git
Vcs-Browser: http://git.debian.org/?p=jppy/jppy.git
Homepage: http://jppy.alioth.debian.org/
XS-Python-Version: >= 2.5

Package: python-jppy
Section: python
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ${python:Depends}, python-reportlab, python-egenix-mxdatetime, python-pisock (>= 0.12.4-3), python-gtk2, python-gtkspell, python-pyparsing, python-glade2, python-gnome2, python-dateutil, python-tz, python-imaging, python-mysqldb
Provides: ${python:Provides}
Replaces: jppy (<< 0.0.38)
Description: Python API to access J-Pilot contacts, memo, and task databases
 This package provides a Python API for accessing the J-Pilot contacts, memo,
 and task databases.

Package: jppy
Section: x11
Architecture: all
Depends: python-jppy (>= ${binary:Version}), ${python:Depends}, python-vobject, jpilot, ${misc:Depends}
Recommends: txt2pdbdoc
Suggests: mutt, jppy-jpilot-plugins
Description: Personal Information Manager using J-Pilot/Palm PDA databases
 jppy is a GUI for manipulating J-Pilot contacts, tasks and memo databases. As
 opposed to the jpilot package, it provides access to the extended fields of
 newer PalmOS contact databases (PalmOS 5 and up).

Package: jppy-doc
Section: doc
Architecture: all
Suggests: jppy
Depends: ${misc:Depends}
Description: Documentation for jppy
 This package installs the documentation for jppy.

Package: jppy-jpilot-plugins
Section: otherosfs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, jppy (= ${source:Version})
Recommends: jpilot
Description: J-Pilot plugins to integrate jppy
 This package installs plugins that integrate jppy with J-Pilot and handles
 synchronisation of the extended contacts database used by newer PalmOS
 (version 5 and up).

Package: jppy-lbdb-module
Section: mail
Architecture: all
Depends: python-jppy (>= ${binary:Version}), ${python:Depends}, ${misc:Depends}
Recommends: lbdb
Description: lbdb module to interface with jppy
 This package provides m_palm_db6, a module to let lbdb query the
 Contacts-PAdd database used by jppy.
